Option Explicit
'
' PPProgress \vt@CNX
'
' VBScript
'
' @version 20120803
' @author  T.Watanabe
'


Class PPProfiles
    '
    ' vpeB
    '
    '
    Public settings
    Private options

    '
    ' RXgN^
    '
    '
    Private Sub Class_Initialize
    
        On Error Resume Next
        If typename(StandardScriptClass) <> "StandardScript" Then
            msgbox "StandardScriptStandardScriptClass̖OŃ[hĂB" & vbcR & "XNvg̋NfO܂B", vbCritical + vbSystemModal, "ReadIni"
            WScript.Quit
        End If
        On Error Goto 0
    
        Set settings = CreateObject("Scripting.Dictionary")
        settings.Add "use_page_icon",   Empty
        settings.Add "use_time_icon",   Empty
        settings.Add "use_page_bar",    Empty
        settings.Add "use_time_bar",    Empty
        settings.Add "use_page_text",   Empty
        settings.Add "use_time_text",   Empty
        settings.Add "page_top",        Empty
        settings.Add "time_top",        Empty
        settings.Add "page_bar_color",  Empty
        settings.Add "time_bar_color",  Empty
        settings.Add "page_bar_transparent",  Empty
        settings.Add "time_bar_transparent",  Empty
        settings.Add "page_bar_height",       Empty
        settings.Add "time_bar_height",       Empty
        settings.Add "page_text_color",       Empty
        settings.Add "time_text_color",       Empty
        settings.Add "page_text_font_family", Empty
        settings.Add "time_text_font_family", Empty
        settings.Add "page_text_font_size",   Empty
        settings.Add "time_text_font_size",   Empty
        settings.Add "page_text_prefix",      Empty
        settings.Add "time_text_prefix",      Empty
        settings.Add "page_text_suffix",      Empty
        settings.Add "page_text_width",       Empty
        settings.Add "time_text_width",       Empty
        settings.Add "page_icon_path",        Empty
        settings.Add "time_icon_path",        Empty
        settings.Add "icon_credit",           Empty
        settings.Add "curtain_color",         Empty
        settings.Add "curtain_transparent",   Empty
        settings.Add "curtain_text_string",   Empty
        settings.Add "curtain_text_color",    Empty
        settings.Add "curtain_text_font_family",Empty
        settings.Add "curtain_text_font_size",Empty
        settings.Add "screen_width",          720
        settings.Add "screen_height",         540

    End Sub

    '
    ' IvVlǉ
    '
    ' @param string key IvVL[
    ' @param string value IvVl
    '
    Public Sub SetOption(key, value)
    
        If settings.Exists(key) Then
            settings.Item(key) = value
        End If
    
    End Sub

    '
    ' IvVlzŒǉ
    '
    ' @param Scripting.Dictionary options IvVl
    '
    Public Sub AddOptions( options )
    
        Dim key
        For Each key In options
            If IsEmpty(options.Item(key)) = False And options.Item(key) <> "" Then
                SetOption key, options.Item(key)
            End If
        Next
    
    End Sub



    '
    ' ̃vpeBlݒ肷
    '
    '
    Public Sub CheckSettings()
'        Dim key
'        For Each key In settings
'            If settings.Item(key) = Empty Then
'                msgbox "vt@Cu" & key & "]ݒ肳Ă܂B"
'            End If
'        Next
    
        
        ' eLXg̃Cfg
        settings.Add "page_text_indent", 0
        If settings.Item("use_page_icon") Then
            settings.Item("page_text_indent") = 12
        End If
        settings.Add "time_text_indent", 0
        If settings.Item("use_time_icon") Then
            settings.Item("time_text_indent") = 12
        End If
        
        ' o[̃Cfg
        settings.Add "page_bar_indent", settings.Item("page_text_indent")
        If settings.Item("use_page_text") Then
            settings.Item("page_bar_indent") = settings.Item("page_text_indent") + settings.Item("page_text_width")
        End If
        settings.Add "time_bar_indent", settings.Item("time_text_indent")
        If settings.Item("use_time_text") Then
            settings.Item("time_bar_indent") = settings.Item("time_text_indent") + settings.Item("time_text_width")
        End If
        
        settings.Item("page_bar_color_rgb") = getRGB( settings.Item("page_bar_color") )
        settings.Item("time_bar_color_rgb") = getRGB( settings.Item("time_bar_color") )

        settings.Item("page_text_color_rgb") = getRGB( settings.Item("page_text_color") )
        settings.Item("time_text_color_rgb") = getRGB( settings.Item("time_text_color") )
        
        settings.Item("curtain_color_rgb") = getRGB( settings.Item("curtain_color") )
        settings.Item("curtain_text_color_rgb") = getRGB( settings.Item("curtain_text_color") )
        
        settings.Item("page_bar_max_width") = settings.Item("screen_width") - settings.Item("page_bar_indent") - 2
        settings.Item("time_bar_max_width") = settings.Item("screen_width") - settings.Item("time_bar_indent") - 2
    
    End Sub


    '
    ' RGBl擾
    '
    ' @param string color_code #000000 `̃J[R[h
    ' @return integer lJ[R[h
    '
    Private Function getRGB( color_code )
        Dim rgb
        If StandardScriptClass.regexTest("^#[0-9a-fA-F]{6}$", color_code ) Then
            rgb = CDbl(StandardScriptClass.regexReplace("#", "&H", color_code))
        Else
            rgb = 1
        End If
        getRGB = rgb
    End Function

End Class
