Option Explicit
'
' PPProgressNX
' PPProgress̎呀
' 
' VBScript
'
' @version 20120729
' @author  T.Watanabe
'
'
'
Class PPProgress

    '
    ' vpeB
    '
    '
    Public PPFileObj      'PowerPoint̃t@CIuWFNg
    Public PPFile         'PowerPoint̃t@CpX
    Private PPApp         'PowerPointAvP[V
    Private PPObj         'PowerPointIuWFNg
    Public total_page     'g[^y[W
    Public time_limit     'Ԑij
    Public wait_time      '[v̏҂ԁibj
'    Private screen_width     'XCh̃XN[
'    Private screen_height    'XCh̃XN[

    Public ReadIniClass     'ReadIniNX

    Public theme            'shapẽe[}
    Private theme_path       'themẽpX
    Private profiles         'themeɂČ߂shapevt@C
    Private options          '[U[ɂĒǉshapevt@C

    Private shapesObj        'shapeIuWFNg
    Private shape_page_bar   'y[WvOXo[
    Private shape_time_bar   'ԃvOXo[
    Private shape_page_text  'y[WvOX
    Private shape_time_text  'ԃvOX
    Private shape_page_icon  'y[WACR
    Private shape_time_icon  'ԃACR
    Private shape_curtain    'VFCv
    Private slideShowObj     'XChV[IuWFNg
    Private current_page     '݂̃y[W
    Private time_limit_sec   'Ԑ b
    Private time_remain_sec  'c莞 b
    Private page_bar_width   'y[WvOXo[
    Private time_bar_width   'ԃvOXo[


    '
    ' RXgN^
    '
    '
    Private Sub Class_Initialize
    
        total_page = 0
        time_limit = 0
        wait_time  = 1
        
        On Error Resume Next
        If typename(StandardScriptClass) <> "StandardScript" Then
            msgbox "StandardScriptStandardScriptClass̖OŃ[hĂB" & vbcR & "XNvg̋NfO܂B", vbCritical + vbSystemModal, "PPProgress"
            WScript.Quit
        End If
        On Error Goto 0
        
        Set ReadIniClass = New ReadIni
    
    End Sub

    '
    ' JnmF
    '
    '
    
    Public Sub start
    
        setProfiles()
        checkProfiles()
        setFile()
        checkFile()
        setTimeLimit()
    
    End Sub

    '
    ' s
    '
    '
    Public Sub process
    
        startPowerPoint()
        setTotalPage()
        show()

    End Sub

    '
    ' vt@C쐬
    '
    '
    Private Sub setProfiles()
    
        Set profiles = New PPProfiles
        If theme = Empty Then
            theme = "default"
        End If        
        ReadTheme( theme )
        
        ReadOptions()
        
    End Sub

    '
    ' e[}̐ݒlǂݎ
    '
    ' @param string theme_name e[}
    '
    Private Sub ReadTheme( theme_name )
    
        theme_path = StandardScriptClass.objFSO.GetFile(WScript.ScriptFullName).ParentFolder & "\theme\" & theme_name & "\"
        If StandardScriptClass.objFSO.FileExists( theme_path & "theme.ini" ) = False Then
            StandardScriptClass.Exception "e[}t@Cǂݎ܂B" & vbCr & theme_path & "theme.ini"
        End If
        profiles.AddOptions( ReadIniClass.getIniFile( theme_path & "theme.ini" ) )
    
    End Sub

    '
    ' e[}JX^}CYIvVw
    '
    '
    Private Sub ReadOptions()
    
        On Error Resume Next
        profiles.AddOptions( ReadIniClass.getIniResource( "options" ) )
        On Error GoTo 0
    
    End Sub


    '
    ' PowerPointt@Cw肷
    '
    '
    Private Sub setFile()

        'hbvꂽt@CŔʂ
        If WScript.Arguments.Count = 1 Then
            PPFile = WScript.Arguments.Item(0)
        ElseIf WScript.Arguments.Count > 1 Then
            StandardScriptClass.Exception "2ȏ̃t@Chbv܂B"
        End If
        
        If StandardScriptClass.objFSO.FileExists(PPFile) Then
            SET PPFileObj = StandardScriptClass.objFSO.getFile( PPFile )
            PPFile = PPFileObj.Path
        Else
            If PPFile = "" Then
                StandardScriptClass.Exception "t@Cw肳Ă܂B"
            Else
                StandardScriptClass.Exception "w肳ꂽt@Cǂݎ܂Bu " & PPFile & "v"
            End If
        End If
        
    End Sub



    '
    ' PowerPoint̃t@Cǂ`FbN
    '
    '
    Private Sub checkFile()
        If StandardScriptClass.regexTest( "PowerPoint", PPFileObj.Type ) = False Then
            StandardScriptClass.Exception "PowerPointȊÕt@Cw肳܂B"
        End If
    End Sub


    '
    ' PowerPointN
    '
    '
    Private Sub startPowerPoint
        Set PPApp = CreateObject("PowerPoint.Application")
        PPApp.Visible = True
        Set PPObj = PPApp.Presentations.Open( PPFile )
    End Sub

    '
    ' y[W擾
    '
    '
    Private Sub setTotalPage
        If total_page = 0 Then
            total_page = PPObj.Slides.count
        ElseIf IsNumeric(total_page) = False Then
            StandardScriptClass.Exception "y[W͐lŎw肵ĂB"
        End If
    End Sub

    '
    ' Ԑ擾
    '
    '
    Private Sub setTimeLimit
    
        If time_limit = 0 Then
            time_limit = StandardScriptClass.input("Ԑ𕪒Pʂœ͂ĂB", "")
        End If

        If time_limit = "" Or IsNumeric(time_limit) = False Then
            StandardScriptClass.Exception "Ԃ͐l(P)Ŏw肵ĂB"
        End If
    
    End Sub


    '
    ' \ݒ̎擾
    '
    '
    Private Sub checkProfiles()
        profiles.checkSettings()
    End Sub

    '
    ' [v
    '
    '
    Private Sub show()
    
        Dim time_start,time_deff_sec,time_remain_str
        Dim last_opend_page
        Dim slide_show_fullscreen
        time_start = now()
        time_limit_sec = time_limit * 60
        time_remain_sec = time_limit_sec

        Set slideShowObj = PPObj.SlideShowSettings.Run()
        slide_show_fullscreen = True

        Do While time_remain_sec > 0

            ' N̊mF
            On Error Resume Next
            IsEmpty(PPObj.SlideShowSettings)
            If Err.Number <> 0 Then
                ' ĂI
                StandardScriptClass.finish()
                WScript.Quit
            End If
            On Error Goto 0

            ' XChV[f̕AE
            On Error Resume Next
            If slide_show_fullscreen = False And PPObj.SlideShowWindow.IsFullScreen Then
                Set slideShowObj = PPObj.SlideShowWindow
                slide_show_fullscreen = True
            Else
                slide_show_fullscreen = False
            End If
            On Error Goto 0

            ' c莞ԕ
            time_remain_str = createTimeString(time_remain_sec)

            On Error Resume Next
            ' ݂̃y[W
            current_page = slideShowObj.View.CurrentShowPosition
            ' ShapesIuWFNg
            Set shapesObj = PPObj.Slides.Item(current_page).Shapes
            On Error Goto 0
            
            
            ' y[WJڂĂ
            If last_opend_page <> current_page Then
                ' VFCv蒼
                createShapes()
            Else
                ' VFCvXV
                refreshShapes()
            End If
            
            ' 萔b܂
            StandardScriptClass.sleep wait_time
            
            ' ̃[vւ̏
            time_deff_sec = ( now - time_start ) * 24 * 60 * 60
            time_remain_sec = time_limit_sec - time_deff_sec
            last_opend_page = current_page
        Loop
        
        ' shapeׂĔj
        deleteShapes()
        
    
    End Sub


    '
    ' bMM:SS̕񐶐
    '
    '
    Private Function createTimeString( time_remain_sec )
        Dim time_remain_str_min,time_remain_str_sec
        time_remain_str_sec = time_remain_sec Mod 60
        time_remain_str_min = Round((time_remain_sec - time_remain_str_sec) / 60)
        If Len(time_remain_str_sec) = 1 Then
            time_remain_str_sec = "0" & time_remain_str_sec
        End If
        createTimeString = time_remain_str_min & ":" & time_remain_str_sec
    End Function

    '
    ' ShapeQ̍쐬
    '
    '
    Private Function createShapes()
        deleteShapes()
        createIcon()
        createText()
        createBar()
    End Function

    '
    ' ShapeQ̔j
    '
    '
    Private Function deleteShapes()
        On Error Resume Next
        shape_page_bar.delete()
        shape_time_bar.delete()
        shape_page_text.delete()
        shape_time_text.delete()
        shape_page_icon.delete()
        shape_time_icon.delete()
        On Error GoTo 0
    End Function

    '
    ' ShapeQ̍XV
    '
    '
    Private Function refreshShapes()
        If profiles.settings.Item("use_page_bar") Then
            shape_page_bar.width = getPageBarWidth()
        End If
        If profiles.settings.Item("use_time_bar") Then
            shape_time_bar.width = getTimeBarWidth()
        End If
        If profiles.settings.Item("use_page_text") Then
            shape_page_text.TextFrame.TextRange.Text = getPageText()
        End If
        If profiles.settings.Item("use_time_text") Then
            shape_time_text.TextFrame.TextRange.Text = getTimeText()
        End If
        
    End Function

    '
    ' Bar̍쐬
    '
    '
    Private Function createBar()
    
        If profiles.settings.Item("use_page_bar") Then
            Set shape_page_bar = shapesObj.Addshape( 1, profiles.settings.Item("page_bar_indent"), profiles.settings.Item("page_top"), getPageBarWidth(), profiles.settings.Item("page_bar_height") )
            shape_page_bar.Fill.Transparency = profiles.settings.Item("page_bar_transparent")
            shape_page_bar.Fill.ForeColor.RGB = profiles.settings.Item("page_bar_color_rgb")
        End If
        If profiles.settings.Item("use_time_bar") Then
            Set shape_time_bar = shapesObj.Addshape( 1, profiles.settings.Item("time_bar_indent"), profiles.settings.Item("time_top"), getTimeBarWidth(), profiles.settings.Item("time_bar_height") )
            shape_time_bar.Fill.Transparency = profiles.settings.Item("time_bar_transparent")
            shape_time_bar.Fill.ForeColor.RGB = profiles.settings.Item("time_bar_color_rgb")
        End If
    
    End Function

    '
    ' Text̍쐬
    '
    '
    Private Function createText()
    
        If profiles.settings.Item("use_page_text") Then
            Set shape_page_text = shapesObj.AddTextbox(1, profiles.settings.Item("page_text_indent"), profiles.settings.Item("page_top"), profiles.settings.Item("page_text_width"), 8)
            shape_page_text.TextFrame.MarginLeft = 0
            shape_page_text.TextFrame.MarginTop = 0
            shape_page_text.TextFrame.MarginBottom = 0
            shape_page_text.TextFrame.MarginRight = 0
            shape_page_text.TextFrame.TextRange.Text = " "
            shape_page_text.TextFrame.TextRange.Font.Name = profiles.settings.Item("page_text_font_family")
            shape_page_text.TextFrame.TextRange.Font.Size = profiles.settings.Item("page_text_font_size")
            shape_page_text.TextFrame.TextRange.Font.Color = profiles.settings.Item("page_text_color_rgb")
            shape_page_text.TextFrame.TextRange.Text = getPageText()
        End If
        If profiles.settings.Item("use_time_text") Then
            Set shape_time_text = shapesObj.AddTextbox(1, profiles.settings.Item("time_text_indent"), profiles.settings.Item("time_top"), profiles.settings.Item("time_text_width"), 8)
            shape_time_text.TextFrame.MarginLeft = 0
            shape_time_text.TextFrame.MarginTop = 0
            shape_time_text.TextFrame.MarginBottom = 0
            shape_time_text.TextFrame.MarginRight = 0
            shape_time_text.TextFrame.TextRange.Text = " "
            shape_time_text.TextFrame.TextRange.Font.Name = profiles.settings.Item("time_text_font_family")
            shape_time_text.TextFrame.TextRange.Font.Size = profiles.settings.Item("time_text_font_size")
            shape_time_text.TextFrame.TextRange.Font.Color = profiles.settings.Item("time_text_color_rgb")
            shape_time_text.TextFrame.TextRange.Text = getTimeText()
        End If
    
    End Function

    '
    ' Icon̍쐬
    '
    '
    Private Function createIcon()
    
        If profiles.settings.Item("use_page_icon") Then
            Set shape_page_icon = shapesObj.AddPicture( theme_path & profiles.settings.Item("page_icon_path"), False, True, 1, profiles.settings.Item("page_top"), 10, 10)
        End If
        If profiles.settings.Item("use_time_icon") Then
            Set shape_time_icon = shapesObj.AddPicture( theme_path & profiles.settings.Item("time_icon_path"), False, True, 1, profiles.settings.Item("time_top"), 10, 10)
        End If
    
    End Function

    '
    ' PageBar̒擾
    '
    '
    Private Function getPageBarWidth()
    
        page_bar_width = ( ( current_page - 1) / ( total_page - 1 ) ) * profiles.settings.Item("page_bar_max_width")
        getPageBarWidth = page_bar_width
    
    End Function

    '
    ' TimeBar̒擾
    '
    '
    Private Function getTimeBarWidth()
    
        time_bar_width = ( 1 - time_remain_sec / time_limit_sec ) * profiles.settings.Item("time_bar_max_width")
        getTimeBarWidth = time_bar_width
    
    End Function

    '
    ' PageText̕񐶐
    '
    '
    Private Function getPageText()
    
        getPageText = profiles.settings.Item("page_text_prefix") & " " & total_page - current_page & " " & profiles.settings.Item("page_text_suffix")
    
    End Function

    '
    ' PageText̕񐶐
    '
    '
    Private Function getTimeText()
    
        Dim res_minutes, res_seconds
        res_minutes = time_remain_sec \ 60
        res_seconds = time_remain_sec mod 60
        If res_seconds < 10 Then
            res_seconds = "0" & res_seconds
        End If
        getTimeText = profiles.settings.Item("time_text_prefix") & " " & res_minutes & ":" & res_seconds
    
    End Function

    '
    ' I_CAO̍쐬
    '
    '
    Public Function finish()
    
        StandardScriptClass.msg "\̎Ԃo߂܂B"
    
    End Function

    '
    ' ̍쐬
    '
    '
    Public Function curtain()
    
        Set shape_curtain = shapesObj.AddShape( 1, 2, 2, profiles.settings.Item("screen_width") - 4, profiles.settings.Item("screen_height") - 4 )
        shape_curtain.Fill.ForeColor.RGB = profiles.settings.Item("curtain_color_rgb")
        shape_curtain.Fill.Transparency = profiles.settings.Item("curtain_transparent")
        shape_curtain.TextFrame.TextRange.Text = profiles.settings.Item("curtain_text_string")
        shape_curtain.TextFrame.TextRange.Font.Name = profiles.settings.Item("curtain_text_font_family")
        shape_curtain.TextFrame.TextRange.Font.Size = profiles.settings.Item("curtain_text_font_size")
        shape_curtain.TextFrame.TextRange.Font.Color = profiles.settings.Item("curtain_text_color_rgb")
        ' hȂƂȂeLXg\Ȃ̂ŕ㏑
        shape_curtain.width = profiles.settings.Item("screen_width") - 4
    
    End Function

    '
    ' PowerPointI
    '
    '
    Public Sub close
    
        On Error Resume Next
        PPObj.Close()
        PPApp.Quit()
        On Error Goto 0
    
    End Sub

    '
    ' NWbg
    '
    '
    Public Sub credit
    
        If (profiles.settings.Item("use_page_icon") Or profiles.settings.Item("use_time_icon")) And IsEmpty(profiles.settings.Item("icon_credit")) = False Then
            StandardScriptClass.msg "- Credit -" & vbCr & vbCr & profiles.settings.Item("icon_credit")
        End If
    
    End Sub


End Class
